;; aus BIBO-Error
;; --------------------------------------------------------------------------------------------------- ;;
;; -- Aufschreiber : Th.Krger , Eberswalde      (Fragmentautoren ??? - Wenn ja, dann Danke )       -- ;;
;; --------------------------------------------------------------------------------------------------- ;;
;; -- Datum : 10.11.03                                                                              -- ;;
;; --------------------------------------------------------------------------------------------------- ;;
;; -- Besonderer Dank an MAPCAR (http://www.autolisp.mapcar.net) fr seinen Error-Handler           -- ;;
;; --------------------------------------------------------------------------------------------------- ;;


;; --------------------------------------------------------------------------------------------------- ;;
;; -- StartErrorHandler : Stapelbare Fehlerbehandlungsroutine                                       -- ;;
;; --                     NAME ist ein frei whlbarer String. Wenn eine (*error*)-Funktion etwas    -- ;;
;; --                     auf dem Bildschirm ausgibt, setzt sie diesen Namen dazu, damit man        -- ;;
;; --                     unterscheiden kann, was von welcher Instanz des Errhandlers kommt.        -- ;;
;; --                     UNDOMODE kann T oder nil sein und gibt an, ob im Fehler- bzw. Abbruchs-   -- ;;
;; --                     fall gleich der Befehl 'Z' ausgefhrt werden soll, um alle bis dahin      -- ;;
;; --                     vorgenommen Aktionen sofort rckgngig zu machen.                         -- ;;
;; --                     VARS_TO_SAVE sind die zu setzenden Systemvariablen und Globalen Variablen -- ;;
;; --------------------------------------------------------------------------------------------------- ;;
;; --  .. Aufruf:         (defun c:Test( / )                                                        -- ;;
;; --                        (startErrorHandler "Funktion TEST" 'T                                  -- ;;
;; --                                           '(("cmdecho"  0)("filedia"  0)("MYOWN" nil))        -- ;;
;; --                        )                                                                      -- ;;
;; --                        .......                                                                -- ;;
;; --                        (endErrorHandler)                                                      -- ;;
;; --                     )                                                                         -- ;;
;; --------------------------------------------------------------------------------------------------- ;;
(defun StartErrorHandler( NAME UNDOMODE VARS_TO_SAVE /
                          ErrorTemplate SAVELIST)  
  ;; --  Schablone fr programmspezifische Fehlerroutine -- ;;
  (setq ErrorTemplate                                        
     '( (MSG / NAME UNDO SAVEDVARS PREVIOUSHANDLER ZAEHLER AUSWAHLSATZ)
         ;... Zeile wird eventuell noch eingesetzt..                                     Siehe unten ....
         (while(>(getvar "cmdactive")0)(command))       ; noch ein "ACAD-Befehl aktiv ??, dann Abbrechen!
    
         (command"_undo""_end")                                                      ; Undo-Endmarkierung
         (if (and undo msg) (command"_u"))              ; wenn Undo True, dann alle Aktionen zurcksetzen
         (foreach PAIR SAVEDVARS                                      ; Vernderte Variablen zurcksetzen
           (if (Getvar (car PAIR))                                         ; ist es eine Systemvariable ?
             (setvar(car PAIR)(cadr PAIR))                                 ; dann zurcksetzen mit SETVAR
             (set (read(car PAIR)) (cadr PAIR))                             ;..sonst mit SET zurcksetzen
           ) 
         )
                 
       
         (setq ZAEHLER 0)
         (setq AUSWAHLSATZ (ssget "X"))
         (while (and AUSWAHLSATZ (setq ELEMENT (ssname AUSWAHLSATZ ZAEHLER)))        
            (redraw ELEMENT 4)                                                   ; Ausleuchten abschalten
           (setq ZAEHLER (1+ ZAEHLER))
         )
      
         (setq *error* previousHandler)            ; Fehlerroutine auf ursprngliche Fehlerroutine setzen
         (if msg
           (progn
             (princ(strcat"\n" Name ": \"" msg "\""))                        ; und Fehlermeldung ausgeben
             (if previousHandler(previousHandler msg))
           )
         )
       )
  )    


  ;; -- Systemvariablen behandeln -- ;

  (if (=(type VARS_TO_SAVE) 'LIST)    
    (foreach PAIR VARS_TO_SAVE  ; Liste mit den Systemvariablen und den zu setzenden  Werten durchlaufen 
      (if (=(type PAIR) 'LIST) 
	(if (=(length PAIR) 2) 
	  (if (=(type(car PAIR)) 'STR)

            (if (Getvar (car PAIR))                           ; konnte Systemvariable ausgelesen werden ?
              (progn
                (setq SAVELIST  (append SAVELIST; Namen der Systemvariable und alten Wert als "2er-Liste"
                                        (list (list (car PAIR) (getvar (car PAIR)))))    ; .. in SAVELIST
                )                                                                         ;  speichern ..
                (setvar(car PAIR)(cadr PAIR))         ; anschlieend Systemvariable auf neuen Wert setzen
              )
              (progn
                (setq SAVELIST  (append SAVELIST      ; Namen der Variable und alten Wert als "2er-Liste"
                                        (list (list (car PAIR) (eval(read(car PAIR)))))) ; .. in SAVELIST
                )                                                                         ;  speichern ..
                (set (read(car PAIR)) (cadr PAIR))          ; anschlieend Variable auf neuen Wert setzen
              )  
            )
          )
        )
      )
    )
  )  

  (command"_undo""_begin")                     ; Undo-Markierung fr "Rckgngig ab diesem Punkt" setzen 

  ;; -- Error-Handler installieren -- ;; 
  (setq *error* 
    (append                                                            ; und ErrorTemplate initialisieren
      (list(car ErrorTemplate))                   ; erste Zeile (Unterliste von ErrorTemplate) hinzufgen
      (if undomode'((setq undo 'T)))                                   ; .. ergnzende Zeilen einfgen ..
      (list
        (list 'setq
          'PreviousHandler
          (cons'quote(list *error*))
        )
      )
      (list(list 'setq 'name name))
      (list
        (cons'setq
          (cons'savedvars
            (list(cons'quote(list savelist)))
          )
        )
      )
      (cdr ErrorTemplate)                                         ; Rest von ErroTemplate hinzufgen ....
    )                                                                                      ; end [APPEND]
  )                                                                                  ; end [SETQ *ERROR*]
)                                                                                           ; end [DEFUN]
;; --------------------------------------------------------------------------------------------------- ;;


;; --------------------------------------------------------------------------------------------------- ;;
;; -- EndErrorHandler : Beendet Nutzerspezifischer Error-Handling                                   -- ;;
;; --------------------------------------------------------------------------------------------------- ;;
(defun EndErrorHandler( / )
  (*error* nil)                                      ; alle nderungen von StartErrorHandler restaurieren
)
;; --------------------------------------------------------------------------------------------------- ;;



;; aus BIBO-SCAN

;; --------------------------------------------------------------------------------------------------- ;;
;; -- SPIN : Funktion zur Spinradausgabe in der Kommandozeile (Kleiner Gimmick)                     -- ;;
;; --        Aufruf (setq SPINSYM (Spin SPINSYM))  mit SPINSYM als bergeordneter Variable          -- ;;
;; --------------------------------------------------------------------------------------------------- ;;
(defun Spin (SYM / )
  (setq SYM   (cond ((= SYM "-" ) "\\")
                    ((= SYM "\\") "|" )
                    ((= SYM "|" ) "/" )
                    ((= SYM "/" ) "-" )
                    (T            "-" )))
  (princ (strcat "\rScanning... " SYM "  "))
  SYM
)
;; --------------------------------------------------------------------------------------------------- ;;
  

;; .. bishierher verschwindet theor. alles in irgentwelchen Bibos

;; --------------------------------------------------------------------------------------------------- ;;
;; -- EXPLODE_AUSWAHL : Auflsen der ausgewhlten Blockreferenzen inclusive der in den Blcken      -- ;;
;; --                   enthaltenen INSERTS                                                         -- ;;
;; --------------------------------------------------------------------------------------------------- ;;
(defun c:EXPLODE_AUSWAHL ( /  AUSWAHL OBJEKT INDEX MODUS SPINSYM )
  
  (startErrorHandler "EXPLODE_AUSWAHL" 'T '(("cmdecho"  0)))  
  (initget "G A")
  (setq MODUS (getkword (strcat "\n<G>anze Zeichnung oder <A>uswahl: <G> ")))
  (if (not MODUS) (setq MODUS "G"))                                  ; Vorgabe bei "Enter"-Eingabe setzen
  (if (= (strcase MODUS) "G")                                         ; die ganze Zeichnung bearbeiten...
   (setq AUSWAHL (ssget "X" '((0 . "INSERT"))))                                                                       
   (setq AUSWAHL (ssget     '((0 . "INSERT"))))        ; sonst gewhlte Objekte (oder nichts) bearbeiten            
  )  
  (if AUSWAHL
    (progn
      (while (> (sslength AUSWAHL) 0 )                            ; und solange INSERT gefunden werden...
        (setq OBJEKT (entlast))                       ; letztes Objekt vor explode-Befehlanwendung merken
        (setq INDEX 0)                                                        ; Auswahlindex auf 0 setzen
        (repeat (sslength AUSWAHL)                                ; Auswahl durchlaufen und abarbeiten...
          (setq SPINSYM (SPIN SPINSYM))
          (if (=(cdr(assoc 0 (entget(ssname AUSWAHL INDEX)))) "INSERT")   ; Element eine Blockreferenz ??
            (command "_.explode" (ssname AUSWAHL INDEX))                               ;... dann auflsen
          )                        
          (setq INDEX(1+ INDEX))                            ; Auswahlindex erhhen und nchstes Element..
        )                                                                                  ; end [REPEAT]

        (setq AUSWAHL(ssadd))                                               ; leeren Auswahlsatz erzeugen
        (setq OBJEKT (entnext OBJEKT))                             ; auf das erste Element nach "Merker"!
        (while OBJEKT          
          (if (=(cdr(assoc 0 (entget OBJEKT))) "INSERT")                        
            (setq AUSWAHL  (ssadd OBJEKT AUSWAHL))               ; Auswahlsatz mit neuen Elementen fllen
          )  
          (setq OBJEKT (entnext OBJEKT))                                         ; nchstes Element holen
        )
      )
    
      (princ "\r........ und Fertig\n")
   
      (initget "J N") 
      (setq MODUS (getkword (strcat "\nUnreferenzierte Blcke bereinigen? <J>a / <N>ein: <J> ")))
      (if (not MODUS) (setq MODUS "J"))                              ; Vorgabe bei "Enter"-Eingabe setzen
      (if (= (strcase MODUS) "J")
        (repeat 6  (command "._purge" "_BL" "*" "_N"))                                 ; und bereinigen !
      )    
  
      (command "._regen")                                                        ; Zeichnung regenerieren
    )
  )      
  (EndErrorHandler)
  (princ)                                                                         ; ohne Rckgabe beenden
)                                                                                           ; end [DEFUN]
;; --------------------------------------------------------------------------------------------------- ;;


(princ "Aufruf mit :  EXPLODE_AUSWAHL")